
;-----------------------------------------
include \masm32\include\masm32rt.inc
;   Sprite4.asm -- A sprite animation
;   based on "C" code from Herbert Schildt's 
;   "Advanced Windows 95 Programming"
;
;   Sound effect added for the cat !	
;   
;   Translated into assembly 28/4/99 by
;   Ron Thomas Ron_Thom@Compuserve.com	
;-----------------------------------------

; Animating a bitmapped sprite

;.586				; 32 bit when .386 appears before .MODEL
;.MODEL FLAT,STDCALL

;include windows.inc

;include user32.inc
;include kernel32.inc
;include gdi32.inc

;includelib user32.lib
;includelib kernel32.lib
;includelib gdi32.lib
;includelib winmm.lib

WinMain		PROTO :DWORD, :DWORD, :DWORD, :SDWORD
run		PROTO STDCALL :DWORD
PlaySound	PROTO	STDCALL :DWORD, :DWORD, :DWORD

.data

BITMAPSIZE	EQU	64

ClassName db "SimpleWinClass",0
AppName   db "Felix went on Walking",0

MYBP1	  db "MYBP1",0			; ID's to bitmap files in Resource file 
MYBP2	  db "MYBP2",0			;
MYBP3	  db "MYBP3",0			;
MASKBIT1  db "MASKBIT1",0		;
MASKBIT2  db "MASKBIT2",0		;
MASKBIT3  db "MASKBIT3",0		;
Play	  db "Meow.wav",0		; Sound file
	
animdim		RECT		<>	; Use for animation area
r		RECT		<>
tm		TEXTMETRIC	<>

X		dd	0		; Current output location
Y		dd	10

maxX		dd	?		; Screen dimensions
maxY		dd	?

bmpdc		HDC	?		; Bitmap device handle

map		dw	0		; Bitmap switch 

hAnBit1		HBITMAP ?		; Animation bitmap handles
hAnBit2		HBITMAP	?
hAnBit3		HBITMAP	?

hbit		HBITMAP	?		; Bitmap handles
hbit2		HBITMAP ?
hbittemp1	HBITMAP ?
hbittemp2	HBITMAP ?	
hbrush		HBRUSH	?		; Brush handle

hmaskbit1	HBITMAP ?		; masks 
hmaskbit2	HBITMAP ?
hmaskbit3	HBITMAP ?

memdc		HDC	?		; Virtual device handle
tempdc1		HDC	?
tempdc2		HDC	?
backgroundDC	HDC	?
	
.data?
hInstance HINSTANCE ?
CommandLine LPSTR ?
;---------------------------------------------------------------------------
.code
start:
	invoke GetModuleHandle, NULL
	mov    hInstance,eax
	invoke GetCommandLine
        invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:SDWORD

	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
        LOCAL hwnd:HWND

	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
        push  hInstance
        pop   wc.hInstance
	mov   wc.hbrBackground,COLOR_WINDOW+1
	mov   wc.lpszMenuName,NULL
	mov   wc.lpszClassName,OFFSET ClassName
        invoke LoadIcon,NULL,IDI_APPLICATION
	mov   wc.hIcon,eax
        mov   wc.hIconSm,0
        invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax 
        invoke RegisterClassEx, addr wc

	invoke LoadBitmap, hInst, ADDR MYBP1	; Load the 3 bitmaps
	mov	hAnBit1,eax 	
	invoke LoadBitmap, hInst, ADDR MYBP2
	mov	hAnBit2,eax 	
	invoke LoadBitmap, hInst, ADDR MYBP3
	mov	hAnBit3,eax

	invoke LoadBitmap, hInst, ADDR MASKBIT1	; Load the masks
	mov	hmaskbit1,eax
	invoke LoadBitmap, hInst, ADDR MASKBIT2
	mov	hmaskbit2,eax
	invoke LoadBitmap, hInst, ADDR MASKBIT3
	mov	hmaskbit3,eax

        INVOKE CreateWindowEx,NULL,ADDR ClassName,ADDR AppName,\
           WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,\
           CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,NULL,NULL,\
           hInst,NULL
        mov   hwnd,eax
        INVOKE ShowWindow, hwnd,SW_SHOWNORMAL
        INVOKE UpdateWindow, hwnd
        .WHILE TRUE
                INVOKE GetMessage, ADDR msg,NULL,0,0
                .BREAK .IF (!eax)
                INVOKE TranslateMessage, ADDR msg
                INVOKE DispatchMessage, ADDR msg
	        invoke run, hwnd			;Cycle the animation
        .ENDW
        mov     eax,msg.wParam
        ret
WinMain endp

WndProc proc uses esi,  hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

        LOCAL  hdc:HDC
        LOCAL  ps:PAINTSTRUCT
		  		
	mov    eax,uMsg

	.IF	eax==WM_CREATE

	  invoke  GetSystemMetrics, SM_CXSCREEN		  
	  mov	  maxX,eax
	  invoke  GetSystemMetrics, SM_CYSCREEN
	  mov	  maxY,eax

;	Create a virtual window

	  invoke  GetDC, hWnd
	  mov	  hdc,eax
	  invoke  CreateCompatibleDC, hdc
	  mov	  memdc,eax
	  invoke  CreateCompatibleBitmap, hdc, maxX, maxY
	  mov	  hbit,eax
	  invoke  SelectObject, memdc, hbit
	  invoke  GetStockObject, WHITE_BRUSH
	  mov	  hbrush,eax
	  invoke  SelectObject, memdc, hbrush
	  invoke  PatBlt, memdc, 0, 0, maxX, maxY, PATCOPY

;	Create background DC

	  invoke  CreateCompatibleDC, hdc
	  mov	  backgroundDC,eax
	  invoke  CreateCompatibleBitmap, hdc, maxX, maxY
	  mov	  hbit2,eax
	  invoke  SelectObject, backgroundDC, hbit2
	  invoke  SelectObject, backgroundDC, hbrush
	  invoke  PatBlt, backgroundDC, 0, 0, maxX, maxY, PATCOPY
	
	  invoke  CreateCompatibleDC, hdc
	  mov	  tempdc1,eax
	  invoke  CreateCompatibleDC, hdc
	  mov	  tempdc2,eax
          invoke  CreateCompatibleBitmap, hdc, BITMAPSIZE, BITMAPSIZE
	  mov	  hbittemp2,eax

          invoke  SelectObject, tempdc2, hbittemp2

;	Draw fence to background

	  mov	  esi,40			; Index

	  .WHILE  esi < 60

	    invoke  MoveToEx, backgroundDC, 0, esi, NULL
	    invoke  LineTo, backgroundDC, maxX, esi
	    add	  esi,10

	  .ENDW

	  mov	  esi,10
	  
	  .WHILE  esi < maxX

	    invoke  MoveToEx, backgroundDC, esi, 40, NULL
	    invoke  LineTo, backgroundDC, esi, 60
	    add	  esi,10

	  .ENDW

	  invoke  BitBlt, memdc, 0, 0, maxX, maxY, backgroundDC, 0, 0, SRCCOPY ;Copy background

	  mov	eax,X			
	  mov	animdim.left,eax		; Update coordinates
	  add	eax,BITMAPSIZE
	  mov	animdim.right,eax		;

	  mov	eax,Y				
	  mov	animdim.top,eax			;			
	  add	eax,BITMAPSIZE
	  mov	animdim.bottom,eax		;

	  invoke  CreateCompatibleDC, hdc
	  mov	  bmpdc,eax
	  invoke  ReleaseDC, hWnd, hdc
	  invoke  InvalidateRect, hWnd, NULL, 1

        .ELSEIF eax==WM_PAINT

          invoke  BeginPaint, hWnd, ADDR ps	; Get DC

          mov	hdc,eax	 ; Get handle to device context before selecting GDI object into it

;	Copy virtual window onto screen

	  mov	eax,ps.rcPaint.right
	  sub	eax,ps.rcPaint.left
	  mov	ecx,ps.rcPaint.bottom
	  sub	ecx,ps.rcPaint.top
	
	  invoke  BitBlt, hdc,   ps.rcPaint.left, ps.rcPaint.top, eax, ecx, \ 
			  memdc, ps.rcPaint.left, ps.rcPaint.top, SRCCOPY

          invoke  EndPaint, hWnd, ADDR ps

	.ELSEIF eax==WM_DESTROY

          invoke  DeleteDC, memdc
	  invoke  DeleteDC, bmpdc
	  invoke  DeleteDC, backgroundDC
	  invoke  DeleteDC, tempdc1
	  invoke  DeleteDC, tempdc2
          invoke  PostQuitMessage,NULL
	    
        .ELSE

            invoke  DefWindowProc, hWnd, uMsg, wParam, lParam
            ret

	.ENDIF
        xor    eax,eax
	ret

WndProc endp

run	Proc	hWnd:HWND		; Cycles the animation

;	Restore the background

	invoke  BitBlt, memdc, X, Y,  BITMAPSIZE, BITMAPSIZE, backgroundDC,  X,Y,   SRCCOPY

;                              TLC    width dest  height dest  handle         TLC    raster  
;                             coords  rectangle   rectangle    source       coords    op   									
;                              destn                             DC         source   code

	inc	X				; Increment X position of sprite

	invoke	GetClientRect, hWnd, ADDR r	; Get current size of client area
						; as this changes with a resize
	mov	eax,X
	inc	eax

	.IF   eax > r.right			; If reach right side, reset to 0

	  mov   X,0
	  ; invoke PlaySound, ADDR Play, NULL, SND_FILENAME or SND_ASYNC ;Cat talks @ end of fence 

	.ENDIF

	inc	map				; Cycle through 3 sprites as animation

	.IF   map > 2
	  mov	map,0
	.ENDIF

;	Switch between sprites

	.IF	map==0

	  invoke  SelectObject, bmpdc, hAnBit1
	  invoke  SelectObject, tempdc1, hmaskbit1
	
	.ELSEIF map==1
	  invoke  SelectObject, bmpdc, hAnBit2
	  invoke  SelectObject, tempdc1, hmaskbit2

	.ELSE    
 
	  invoke  SelectObject, bmpdc, hAnBit3
	  invoke  SelectObject, tempdc1, hmaskbit3

	.ENDIF

;	AND masking image on background

	  invoke  BitBlt, memdc, X, Y,  BITMAPSIZE, BITMAPSIZE, tempdc1,   0, 0,   SRCAND

;                                TLC    width dest  height dest  handle     TLC     raster  
;                               coords  rectangle   rectangle    source   coords     op   									
;                               destn                             DC      source    code

;	Invert the mask

	  invoke  BitBlt, tempdc1, 0, 0,  BITMAPSIZE, BITMAPSIZE, tempdc1, 0, 0,   DSTINVERT

;	Copy sprite to work area

	  invoke  BitBlt, tempdc2, 0, 0,  BITMAPSIZE, BITMAPSIZE,   bmpdc, 0, 0,   SRCCOPY

;	AND sprite with inverted mask

	  invoke  BitBlt, tempdc2, 0, 0,  BITMAPSIZE, BITMAPSIZE, tempdc1, 0, 0,   SRCAND

;	Restore mask

	  invoke  BitBlt, tempdc1, 0, 0,  BITMAPSIZE, BITMAPSIZE, tempdc1, 0, 0,   DSTINVERT

;	OR resulting image onto background

	  invoke  BitBlt, memdc, X, Y,  BITMAPSIZE, BITMAPSIZE,   tempdc2, 0, 0,   SRCPAINT


	mov	eax,X			
	mov	animdim.left,eax		; Update coordinates
	add	eax,BITMAPSIZE
	mov	animdim.right,eax		;

	mov	eax,Y				
	mov	animdim.top,eax			;			
	add	eax,BITMAPSIZE
	mov	animdim.bottom,eax		;

	invoke	Sleep, 50			; Slow animation down with n msec delay
						; *** alter to suit your own system ***
  
	invoke	InvalidateRect, hWnd, ADDR animdim,0	; Force update of animation 
	
	ret
run	ENDP

        end start

OPT_Tmp2Asm	1
